      *****************************************
      * Program name: dep.cbl
      * This web-based program provides examples of 
      * depreciation function usage and HTML gldi
      * usage.
      *
      * Copyright 2000 Deskware, Inc.
      *****************************************

       1 depreciation_method PIC XXX VALUE `DDB`.

       1 content_length         PIC 9(05).

       1 web_page_top.
         5 `Content-type: text/html`.
         5 ` `.
         5 `<HTML><BODY>`.
         5 `<FORM ACTION="/cgi-bin/cobolscript.exe?dep.cbl" METHOD="POST">`.
         5 `<TABLE BORDER=1>`.
         5 `<TR BGCOLOR="99CCFF"><TD>Cost of Asset</TD><TD>Life of Asset</TD><TD>Salvage Value of Asset</TD><TD>&nbsp;</TD></TR>`.

         5 `<TR BGCOLOR="6699CC">`.
         5 `<TD><INPUT TYPE="TEXT" NAME="cost" VALUE="`.

         5 cost  PIC ZZZZZ9.99 VALUE 10000.

         5 `"></TD>`.
         5 `<TD><INPUT TYPE="TEXT" NAME="life" VALUE="`.

         5 life  PIC Z9 VALUE 5.

         5 `"></TD>`.
         5 `<TD><INPUT TYPE="TEXT" NAME="salvage_value" VALUE="`. 

         5 salvage_value PIC ZZZZZ9.99 VALUE 100.

         5 `"></TD>`.
         5 `<TD><INPUT TYPE="SUBMIT" VALUE="Calculate Depreciation Schedule"></TD>`.
         5 `</TR>`.
         5 `</FORM>`.


       1 depreciation_header_html.
         5 `</TABLE>`.
         5 `<BR><BR><B>`.
         5 method_text PIC X(50) VALUE `Double Declining Balance Depreciation Schedule`.
         5 `</B><BR><BR>`.
         5 `<TABLE BORDER=1><TR BGCOLOR="99CCFF">`.
         5 `<TD>Period</TD>`.
         5 `<TD>Depreciation Amount</TD>`.
         5 `<TD>Remaining Asset Value</TD>`.
         5 `<TD>Total Amount Depreicated</TD>`.
         5 `</TR>`.


       1 depreciation_html.
         5 `<TR BGCOLOR="CCCCCC">`.

         5 `<TD align=center>`.
         5 period  PIC 99 VALUE 0.
         5 `</TD>`.

         5 `<TD align=right>`.
         5 dep_amt  PIC $$$$$.99.
         5 `</TD>`.

         5 `<TD align=right>`.
         5 remaining_asset_value PIC $$$$$$.99.
         5 `</TD>`.

         5 `<TD align=right>`.
         5 amount_depreciated  PIC $$$$$$.99.
         5 `</TD>`.
         5 `</TR>`.


       1 footer_html.
         5 `</TABLE></BODY></HTML>`.


       MAIN.
           GETENV USING `CONTENT_LENGTH` content_length.
           IF content_length > 0
              ACCEPT DATA FROM WEBPAGE
           END-IF.

           DISPLAYLF web_page_top.

      * DDB-specific calculations and HTML
           DISPLAYLF depreciation_header_html.

           MOVE cost TO remaining_asset_value.
           MOVE 0 TO amount_depreciated.
           MOVE `DDB` TO depreciation_method.
           PERFORM CALC-DEPRECIATION VARYING period FROM 1 BY 1 UNTIL period > life.

      * SYD-specific calculations and HTML
           MOVE `Sum-of-Years Digits Depreciation Schedule` TO method_text.
           DISPLAYLF depreciation_header_html.

           MOVE cost TO remaining_asset_value.
           MOVE 0 TO amount_depreciated.
           MOVE `SYD` TO depreciation_method.
           PERFORM CALC-DEPRECIATION VARYING period FROM 1 BY 1 UNTIL period > life.

      * Straight-line-specific calculations and HTML
           MOVE `Straight Line Depreciation Schedule` TO method_text.
           DISPLAYLF depreciation_header_html.

           MOVE cost TO remaining_asset_value.
           MOVE 0 TO amount_depreciated.
           MOVE `SLM` TO depreciation_method.
           PERFORM CALC-DEPRECIATION VARYING period FROM 1 BY 1 UNTIL period > life.

      * Footer HTML
           DISPLAY footer_html.

           STOP RUN.

      *******************************************************
      * MODULE: CALC-DEPRECIATION                       
      *                                                  
      * DESCRIPTION: Calculates depreciation, using different
      * methods for different values of depreciation_method
      * variable.
      *******************************************************
       CALC-DEPRECIATION.

           IF depreciation_method = `DDB`
              COMPUTE dep_amt = DDBAMT(cost, life, period, salvage_value)
           ELSIF depreciation_method = `SYD`
              COMPUTE dep_amt = SYDAMT(cost, life, period, salvage_value)
           ELSIF depreciation_method = `SLM`
              COMPUTE dep_amt = STRLINEAMT(cost, life, salvage_value)
           ELSE
              DISPLAY `<br><b>Unknown depreciation method.</b><br><br>`
              COMPUTE period = life + 1
           END-IF.

           COMPUTE remaining_asset_value = remaining_asset_value - dep_amt.
           COMPUTE amount_depreciated = amount_depreciated + dep_amt.

           DISPLAY depreciation_html.