      *****************************************
      * CobolScript program name: dns.cbl
      * This web-based program provides an example 
      * of GETHOSTBYNAME usage, of array usage, 
      * of storing html in gldi's, and of inline
      * PERFORM VARYINGs. 
      *
      * Copyright 2000 Deskware, Inc.
      *****************************************
      * Include the TCP/IP variable copybook.
       COPY `tcpip.cpy`.

       1 content_length   PIC 9(05).

       1 web_header_html.
        5 `Content-type: text/html`.
        5 ` `.
        5 `<HTML><BODY>`.
        5 `<BR>`.
        5 `<B>Sample CobolScript DNS Application</B>`.
        5 `<BR><BR>`.
        5 `Enter a Fully Qualified Domain Name or an IP address and then click on the Resolve button.`.
        5 `<FORM ACTION="/cgi-bin/cobolscript.exe?dns.cbl" METHOD="POST">`.
        5 `<INPUT TYPE="TEXT" NAME="host_name" SIZE=60 VALUE="`.
        5 host_name  PIC X(80) VALUE `www.cornell.edu`.
        5 `">`.
        5 `<INPUT TYPE="SUBMIT" VALUE="Resolve">`.
        5 `</FORM>`.
        5 `<HR>`.

       1 web_footer_html.
        5 `</BODY></HTML>`.

       MAIN.
           GETENV USING `CONTENT_LENGTH` content_length.

           IF content_length > 0
              ACCEPT DATA FROM WEBPAGE
           END-IF.

           IF host_name = SPACES
              MOVE `www.cornell.edu` TO host_name
           END-IF.

      * Populate TCP/IP structure that is defined in included copybook.
           GETHOSTBYNAME USING host_name.

           DISPLAYLF web_header_html.
           PERFORM DISPLAY-TCPIP-INFO.
           DISPLAYLF web_footer_html.

           GOBACK.

       DISPLAY-TCPIP-INFO.

            1 counter PIC Z9.

            DISPLAY `<TABLE BORDER=1 BGCOLOR="CCCCCC">`.

            DISPLAY `<TR BGCOLOR="lightgreen">`.
            DISPLAY `<TD><B>host_name:</B></TD>`.
            DISPLAY `<TD><B>` & host_name & `</B></TD>`.
            DISPLAY `</TR>`.


            DISPLAY `<TR BGCOLOR="BBFFDD">`.
            DISPLAY `<TD>TCPIP-RETURN-CODE: </TD>`.
            DISPLAY `<TD>` & TCPIP-RETURN-CODE & `</TD>`.
            DISPLAY `</TR>`.

            DISPLAY `<TR BGCOLOR="BBFFDD">`.
            DISPLAY `<TD>TCPIP-RETURN-MESSAGE: </TD>`.
            DISPLAY `<TD>` & TCPIP-RETURN-MESSAGE & `&nbsp;</TD>`.
            DISPLAY `</TR>`.

            DISPLAY `<TR>`.
            DISPLAY `<TD>TCPIP-HOSTENT-HOSTNAME: </TD>`.
            DISPLAY `<TD>` & TCPIP-HOSTENT-HOSTNAME & `&nbsp;</TD>`.
            DISPLAY `</TR>`.

            DISPLAY `<TR>`.
            DISPLAY `<TD>TCPIP-HOSTENT-ADDRESS-TYPE: </TD>`.
            DISPLAY `<TD>` & TCPIP-HOSTENT-ADDRESS-TYPE & `</TD>`.
            DISPLAY `</TR>`.

            DISPLAY `<TR>`.
            DISPLAY `<TD>TCPIP-HOSTENT-ADDRESS-LENGTH: </TD>`.
            DISPLAY `<TD>` & TCPIP-HOSTENT-ADDRESS-LENGTH & `</TD>`.
            DISPLAY `</TR>`.

            DISPLAY `<TR>`.
            DISPLAY `<TD>TCPIP-HOSTENT-NUM-ADDRESSES: </TD>`.
            DISPLAY `<TD>` & TCPIP-HOSTENT-NUM-ADDRESSES & `&nbsp;</TD>`.
            DISPLAY `</TR>`.

      * Display all hostent-address elements from inside inline PERFORM loop 
            PERFORM VARYING counter FROM 1 BY 1 UNTIL counter > 8
               DISPLAY `<TR BGCOLOR="lightblue">`
               DISPLAY `<TD>TCPIP-HOSTENT-ADDRESS(`  &  counter  &  `): </TD>`
               DISPLAY `<TD>`  &  TCPIP-HOSTENT-ADDRESS(counter)  &  `&nbsp;</TD>`
               DISPLAY `</TR>`
            END-PERFORM.

            DISPLAY `<TR>`.
            DISPLAY `<TD>TCPIP-HOSTENT-NUM-ALIASES: </TD>`.
            DISPLAY `<TD>` & TCPIP-HOSTENT-NUM-ALIASES & `&nbsp;</TD>`.
            DISPLAY `</TR>`.

      * Display all hostent-alias elements from inside inline PERFORM loop
            PERFORM VARYING counter FROM 1 BY 1 UNTIL counter > 8
               DISPLAY `<TR BGCOLOR="lightblue">`
               DISPLAY `<TD>TCPIP-HOSTENT-ALIAS(`  &  counter  &  `): </TD>`
               DISPLAY `<TD>`  &  TCPIP-HOSTENT-ALIAS(counter)  &  `&nbsp;</TD>`
               DISPLAY `</TR>`
            END-PERFORM.

            DISPLAY `</TABLE>`.




